| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Namespace List
- Namespace Members

Classes | Typedefs | Functions
Gaudi::Functional::details::details2 Namespace Reference

## Classes
struct | get_from_handle
struct | remove_optional
struct | remove_optional< boost::optional< T > >

## Typedefs
template<std::size_t N, typename Tuple >
using | element_t = typename std::tuple_element< N, Tuple >::type

## Functions
template<typename Container , typename Value >
void | push_back (Container &c, const Value &v, std::true_type)
template<typename Container , typename Value >
void | push_back (Container &c, const Value &v, std::false_type)
template<typename T >
T * | deref_if (T *const t, std::false_type)
template<typename T >
T & | deref_if (T *const t, std::true_type)
template<typename Tuple , typename KeyValues , std::size_t... I>
Tuple | make_tuple_of_handles_helper (IDataHandleHolder *o, const KeyValues &initvalue, Gaudi::DataHandle::Mode m, std::index_sequence< I... >)
template<typename KeyValues , typename Properties , std::size_t... I>
void | declare_tuple_of_properties_helper (GaudiAlgorithm *owner, const KeyValues &inputs, Properties &props, std::index_sequence< I... >)

## Typedef Documentation

template<std::size_t N, typename Tuple >

using Gaudi::Functional::details::details2::element_t = typedef typename std::tuple_element<N, Tuple>::type

Definition at line 275 of file FunctionalDetails.h.

## Function Documentation

template<typename KeyValues , typename Properties , std::size_t... I>

void Gaudi::Functional::details::details2::declare_tuple_of_properties_helper | ( | GaudiAlgorithm * | owner,
|  | const KeyValues & | inputs,
|  | Properties & | props,
|  | std::index_sequence< I... > |
| ) |  |

Definition at line 282 of file FunctionalDetails.h.

282 {
283 // note: be very careful here! Only GaudiAlgorithm has a declareProperty that works with a DataObjectHandleBase.
284 // However, Algorithm does have a template that also matches (unless it is constrained explicitly against matching)
285 // so if 'owner' is of type Algorithm instead of GaudiAlgortihm, this ends up calling the wrong declareProperty...
286 (void) std::initializer_list<int>{
287 ( owner->declareProperty( std::get<I>(inputs).first,
288 std::get<I>(props) ),0)...
289 };
290 }
Gaudi::Functional::void
class MergingTransformer< Out(const vector_of_const_< In > void
Definition: MergingTransformer.h:19
BrunelScenarioForwardScheduler.inputs
inputs
Definition: BrunelScenarioForwardScheduler.py:123
Algorithm::declareProperty
Gaudi::Details::PropertyBase * declareProperty(const std::string &name, ToolHandle< T > &hndl, const std::string &doc="none")
Definition: Algorithm.h:366
std::initializer_list
template<typename T >

T* Gaudi::Functional::details::details2::deref_if | ( | T *const | t,
|  | std::false_type |
| ) |  |

Definition at line 166 of file FunctionalDetails.h.

166 { return t; }
template<typename T >

T& Gaudi::Functional::details::details2::deref_if | ( | T *const | t,
|  | std::true_type |
| ) |  |

Definition at line 167 of file FunctionalDetails.h.

167 { return *t; }
template<typename Tuple , typename KeyValues , std::size_t... I>

Tuple Gaudi::Functional::details::details2::make_tuple_of_handles_helper | ( | IDataHandleHolder * | o,
|  | const KeyValues & | initvalue,
|  | Gaudi::DataHandle::Mode | m,
|  | std::index_sequence< I... > |
| ) |  |

Definition at line 278 of file FunctionalDetails.h.

278 {
279 return std::make_tuple( element_t<I,Tuple>{std::get<I>(initvalue).second, m, o} ... );
280 }
std::make_tuple
T make_tuple(T...args)
Gaudi::Units::second
constexpr double second
Definition: SystemOfUnits.h:122
Gaudi::Units::m
constexpr double m
Definition: SystemOfUnits.h:93
template<typename Container , typename Value >

void Gaudi::Functional::details::details2::push_back | ( | Container & | c,
|  | const Value & | v,
|  | std::true_type |
| ) |  |

Definition at line 154 of file FunctionalDetails.h.

154 { c.push_back(v); }
gaudirun.c
c
Definition: gaudirun.py:391
template<typename Container , typename Value >

void Gaudi::Functional::details::details2::push_back | ( | Container & | c,
|  | const Value & | v,
|  | std::false_type |
| ) |  |

Definition at line 156 of file FunctionalDetails.h.

156 { c.push_back(&v); }
gaudirun.c
c
Definition: gaudirun.py:391